<!--
 * @Author: zhp
 * @Date: 2023-02-14 15:02:26
 * @LastEditTime: 2023-05-15 14:30:34
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-form :model="dataForm" ref="dataForm" @keyup.enter.native="dataFormSubmitHandle()" label-width="150px">
    <el-form-item prop="title" :label="$t('laboratory.title')">
      <el-input v-model="dataForm.title" :placeholder="$t('laboratory.title')">
      </el-input>
    </el-form-item>
    <el-form-item prop="trainContent" :label="$t('laboratory.trainContent')">
      <el-input v-model="dataForm.trainContent" :placeholder="$t('laboratory.trainContent')">
      </el-input>
    </el-form-item>
    <el-form-item prop="trainDuration" :label="$t('laboratory.trainDuration')">
      <el-input v-model="dataForm.trainDuration" :placeholder="$t('laboratory.trainDuration')">
      </el-input>
    </el-form-item>
    <el-form-item prop="trainType" :label="$t('laboratory.trainType')">
      <el-input v-model="dataForm.trainType" :placeholder="$t('laboratory.trainType')">
      </el-input>
    </el-form-item>
    <el-form-item prop="result" :label="$t('laboratory.result')">
      <el-input v-model="dataForm.result" :placeholder="$t('laboratory.result')">
      </el-input>
    </el-form-item>
    <el-form-item prop="trainDate" :label="$t('laboratory.trainDate')">
      <el-date-picker v-model="dataForm.trainDate" type="datetime" :placeholder="$t('laboratory.trainDate')"
        format='yyyy-MM-dd HH:mm:ss' valueFormat='yyyy-MM-ddTHH:mm:ss'>
      </el-date-picker>
    </el-form-item>
  </el-form>
</template>

<script>
import debounce from "lodash/debounce";
import basicAdd from "@/mixins/basic-add";
export default {
  mixins: [basicAdd],
  data() {
    return {
      urlOptions: {
        submitURL: "/laboratory/qmsLaboratoryTrainExperience",
        infoURL: "/laboratory/qmsLaboratoryTrainExperience/{ id }",
      },
      gageList: [],
      userList: [],
      customerList:[],
      gageTypeList:[],
      departmentList: [],
      listQuery: {
        limit: 999,
        page: 1
      },
      visible: false,
      dataForm: {
        id: null,
        laboratoryTesterId:null,
        result: null,
        title: null,
        trainContent: null,
        trainDate: null,
        trainDuration: null,
        trainType: null,
      },
    };
  },
  computed: {
    dataRule() {
      return {
        // dictLabel: [
        //   {
        //     required: true,
        //     message: this.$t("validate.required"),
        //     trigger: "blur",
        //   },
        // ],
        // dictValue: [
        //   {
        //     required: true,
        //     message: this.$t("validate.required"),
        //     trigger: "blur",
        //   },
        // ],
        // sort: [
        //   {
        //     required: true,
        //     message: this.$t("validate.required"),
        //     trigger: "blur",
        //   },
        // ],
      };
    },
  },
  // mounted () {
  //   this.getData();
  // },
  methods: {
    init(data) {
      this.dataForm.id = data.id ? data.id : ''
      this.dataForm.laboratoryTesterId = data.laboratoryTesterId ? data.laboratoryTesterId : ''
      // console.log(11111)
      // this.dataForm.dictTypeId = dictTypeId || "";
      this.visible = true
      this.$nextTick(() => {
        this.$refs["dataForm"].resetFields();
        if (this.dataForm.id) {
          this.getInfo()
        } else {
          // this.getCode()
        }
      });
    },
    // getData() {
    //   this.$http.get(this.urlOptions.getGageList, {
    //       params: this.listQuery,
    //     })
    //     .then(({ data: res }) => {
    //       if (res.code === 0) {
    //         console.log(res.data)
    //         this.gageList = res.data.list
    //       }
    //     })
    //     .catch(() => {
    //     })
    //   this.$http
    //     .get(this.urlOptions.getUserList, this.listQuery)
    //     .then(({ data: res }) => {
    //       if (res.code === 0) {
    //         console.log(res.data);
    //         this.userList = res.data.list
    //       }
    //     })
    //     .catch(() => {
    //     })
    // },
    // getCode() {
    //   this.$http.post(this.urlOptions.getCodeURL)
    //     .then(({ data: res }) => {
    //       if (res.code === 0) {
    //         console.log(res);
    //         this.dataForm.customSamplingCode = res.data
    //       }
    //     })
    //     .catch(() => {
    //     });
    // },
    // 获取信息
    getInfo() {
      this.$http
        .get(`/laboratory/qmsLaboratoryTrainExperience/${this.dataForm.id}`)
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.dataForm = {
            ...this.dataForm,
            ...res.data,
          };
        })
        .catch(() => { })
    },
    // 表单提交
    dataFormSubmitHandle: debounce(
      function () {
        this.$refs["dataForm"].validate((valid) => {
          if (!valid) {
            return false;
          }
          this.$http[!this.dataForm.id ? "post" : "put"](this.urlOptions.submitURL, this.dataForm)
            .then(({ data: res }) => {
              if (res.code !== 0) {
                return this.$message.error(res.msg);
              }
              this.$message({
                message: this.$t("prompt.success"),
                type: "success",
                duration: 500,
                onClose: () => {
                  console.log(1111);
                  this.visible = false;
                  this.$emit("successSubmit");
                },
              });
            })
            .catch(() => {});
        });
      },
      1000,
      { leading: true, trailing: false }
    ),
  },
};
</script>
